require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&X86_64_MSR_H)) {
    eval 'sub X86_64_MSR_H {1;}' unless defined(&X86_64_MSR_H);
    require 'asm/msr-index.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/errno.ph';
	eval 'sub rdmsr {
	    my($msr,$val1,$val2) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdmsr);
	eval 'sub rdmsrl {
	    my($msr,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdmsrl);
	eval 'sub wrmsr {
	    my($msr,$val1,$val2) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&wrmsr);
	eval 'sub wrmsrl {
	    my($msr,$val) = @_;
    	    eval q( &wrmsr($msr,( &__u32)(( &__u64)($val)),(( &__u64)($val))>>32));
	}' unless defined(&wrmsrl);
	eval 'sub wrmsr_safe {
	    my($msr,$a,$b) = @_;
    	    eval q(({ \'int\'  &ret__;  &asm  &volatile(\\"2: wrmsr ; xorl %0,%0\\\\n\\" \\"1:\\\\n\\\\t\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\\\t\\" \\"3:  movl %4,%0 ; jmp 1b\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\"   .align 8\\\\n\\\\t\\" \\"   .quad 	2b,3b\\\\n\\\\t\\" \\".previous\\" : \\"=a\\" ( &ret__) : \\"c\\" ($msr), \\"0\\" ($a), \\"d\\" ($b), \\"i\\" (- &EFAULT));  &ret__; }));
	}' unless defined(&wrmsr_safe);
	eval 'sub checking_wrmsrl {
	    my($msr,$val) = @_;
    	    eval q( &wrmsr_safe($msr,( &u32)($val),( &u32)(($val)>>32)));
	}' unless defined(&checking_wrmsrl);
	eval 'sub rdmsr_safe {
	    my($msr,$a,$b) = @_;
    	    eval q(({ \'int\'  &ret__;  &asm  &volatile (\\"1:       rdmsr\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:       movl %4,%0\\\\n\\" \\" jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\" \\" .align 8\\\\n\\" \\" .quad 1b,3b\\\\n\\" \\".previous\\":\\"=&bDS\\" ( &ret__), \\"=a\\"(*($a)), \\"=d\\"(*($b)) :\\"c\\"($msr), \\"i\\"(- &EIO), \\"0\\"(0));  &ret__; }));
	}' unless defined(&rdmsr_safe);
	eval 'sub rdtsc {
	    my($low,$high) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdtsc);
	eval 'sub rdtscl {
	    my($low) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdtscl);
	eval 'sub rdtscp {
	    my($low,$high,$aux) = @_;
    	    eval q( &asm  &volatile (\\".byte 0x0f,0x01,0xf9\\" : \\"=a\\" ($low), \\"=d\\" ($high), \\"=c\\" ($aux)));
	}' unless defined(&rdtscp);
	eval 'sub rdtscll {
	    my($val) = @_;
    	    eval q( &do { \'unsigned int __a\', &__d;  &asm  &volatile(\\"rdtsc\\" : \\"=a\\" ( &__a), \\"=d\\" ( &__d)); ($val) = ( &__a) | (( &__d)<<32); }  &while(0));
	}' unless defined(&rdtscll);
	eval 'sub rdtscpll {
	    my($val, $aux) = @_;
    	    eval q( &do { \'unsigned long __a\',  &__d;  &asm  &volatile (\\".byte 0x0f,0x01,0xf9\\" : \\"=a\\" ( &__a), \\"=d\\" ( &__d), \\"=c\\" ($aux)); ($val) = ( &__d << 32) |  &__a; }  &while (0));
	}' unless defined(&rdtscpll);
	eval 'sub write_tsc {
	    my($val1,$val2) = @_;
    	    eval q( &wrmsr(0x10, $val1, $val2));
	}' unless defined(&write_tsc);
	eval 'sub write_rdtscp_aux {
	    my($val) = @_;
    	    eval q( &wrmsr(0xc0000103, $val, 0));
	}' unless defined(&write_rdtscp_aux);
	eval 'sub rdpmc {
	    my($counter,$low,$high) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&rdpmc);
	eval 'sub cpuid {
	    my($op,$eax,$ebx,$ecx,$edx) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&cpuid);
	eval 'sub cpuid_ebx {
	    my($op) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&cpuid_ebx);
	eval 'sub cpuid_ecx {
	    my($op) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&cpuid_ecx);
	eval 'sub cpuid_edx {
	    my($op) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&cpuid_edx);
	if(defined(&CONFIG_SMP)) {
	} else {
	    eval 'sub rdmsr_on_cpu {
	        my($cpu,$msr_no,$l,$h) = @_;
    		eval q({  &rdmsr($msr_no, *$l, *$h); });
	    }' unless defined(&rdmsr_on_cpu);
	    eval 'sub wrmsr_on_cpu {
	        my($cpu,$msr_no,$l,$h) = @_;
    		eval q({  &wrmsr($msr_no, $l, $h); });
	    }' unless defined(&wrmsr_on_cpu);
	    eval 'sub rdmsr_safe_on_cpu {
	        my($cpu,$msr_no,$l,$h) = @_;
    		eval q({  &rdmsr_safe($msr_no, $l, $h); });
	    }' unless defined(&rdmsr_safe_on_cpu);
	    eval 'sub wrmsr_safe_on_cpu {
	        my($cpu,$msr_no,$l,$h) = @_;
    		eval q({  &wrmsr_safe($msr_no, $l, $h); });
	    }' unless defined(&wrmsr_safe_on_cpu);
	}
    }
}
1;
